theory MyLecture
  imports Main
begin


lemma sleeper: "S \<noteq> {} \<Longrightarrow>
  \<exists> x \<in> S. (sleeps x \<longrightarrow> (\<forall> y \<in> S. sleeps y))"
  by auto

lemma sleep:
  fixes S :: "'a set" and sleeps :: "'a \<Rightarrow> bool"
  assumes nonEmpty: "S \<noteq> {}"
  shows "\<exists> x \<in> S. (sleeps x \<longrightarrow> (\<forall> y \<in> S. sleeps y))"
    (is "\<exists> x \<in> S. (sleeps x \<longrightarrow> ?allSleep)")
proof cases
  assume firmly: ?allSleep
  from nonEmpty obtain someA where "someA \<in> S" by auto 
  from this show ?thesis using firmly by auto
next
  assume "\<not> ?allSleep"
  from this obtain awakeOne where 
    isAwake: "\<not> sleeps awakeOne \<and> awakeOne \<in> S" by auto
  from this have "sleeps awakeOne \<longrightarrow> ?allSleep" by auto
  from this show ?thesis using isAwake by auto
qed

lemma slp:
  fixes S :: "'a set" and sleeps :: "'a \<Rightarrow> bool"
  assumes nonEmpty: "S \<noteq> {}"
  shows "\<exists> x \<in> S. (sleeps x \<longrightarrow> (\<forall> y \<in> S. sleeps y))" 
    (is "\<exists> x \<in> S. (sleeps x \<longrightarrow> ?allSleep)")
proof (cases ?allSleep)
  assume firmly: ?allSleep
  from nonEmpty obtain someA where "someA \<in> S" by auto 
  thus ?thesis using firmly by auto
next
  assume "\<not> ?allSleep"
  then obtain awakeOne where 
    isAwake: "\<not> sleeps awakeOne \<and> awakeOne \<in> S" by auto
  hence "sleeps awakeOne \<longrightarrow> ?allSleep" by auto
  thus ?thesis using isAwake by auto
qed

end